/* 
    This file is part of the ChemCon molecular mechanics 
    and molecular graphics program.

    Copyright (C) 1997-2002  Alexei Nikitin 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef RAND_H
#define RAND_H

#define T_Base_random__TABLE_SIZE  113

class    T_Base_random
  {
    private:

      unsigned  long              value, valueX, valueY;
      double                      rmin;
      double                      rmax;
      unsigned  long              table[ T_Base_random__TABLE_SIZE ];

    protected:

      unsigned  long              calc();
      void                        fill_table();

    public:
 
      enum                        Methods{ WATCOM, Knuth, Koveu, Bad, Mix };
                        
      double                      next( void );
      double                      next( double __rmax );
      double                      next( double __rmin, double __rmax );

      void                        srand( unsigned long seed);
      void                        randomize(void);
      void                        set_method( Methods m );
      void                        set_range( double __rmin, double __rmax );

      T_Base_random();
      T_Base_random( double __rmax );
      T_Base_random( double __rmin, double __rmax );
//   ~Base_randoms ();
    private:

      enum                        Methods method;
                
  };

#endif//RAND_H
