#include "Visual_atom_composite.h"

namespace MM
{

Visual_atom * Visual_atom_composite::
clone () const
{
    Visual_atom_composite *result = new Visual_atom_composite;

    for (int i=0;  i<count();  ++i)
        result->adopt (atom_[i].clone());

    return result;
}

void Visual_atom_composite::
adopt (Visual_atom *adoptee)
{
    atom_.push_back (adoptee);
}

void Visual_atom_composite::
show () const
{
    for (int i=0;  i<count();  ++i)
        atom_[i].show();
}

void Visual_atom_composite::
hide () const
{
    for (int i=0;  i<count();  ++i)
        atom_[i].hide();
}

void Visual_atom_composite::
update_view_type   (View_atom_type & type)
{
    for (int i=0;  i<count();  ++i)
    {
        //atom_[i].update_view_type (type);
        Visual_atom & current = atom_[i];
        current.update_view_type (type);
    }
}

void Visual_atom_composite::
update_coordinates (double x, double y, double z)
{
    for (int i=0;  i<count();  ++i)
        atom_[i].update_coordinates (x, y, z);
}

/*void Visual_atom_composite::
get_color (int *R, int *G, int *B)
{
    if (count() > 0)
        atom_[0].get_color (R, G, B);
}//*/

void Visual_atom_composite::
set_color (int R, int G, int B)
{
    for (int i=0;  i<count();  ++i)
        atom_[i].set_color (R, G, B);
}

void Visual_atom_composite::
set_level_of_details (int lod)
{
    for (int i=0;  i<count();  ++i)
        atom_[i].set_level_of_details (lod);
}//*/

}//MM

