#ifndef MODULE_H
#define MODULE_H

#include "Module_handle.h"
#include "Array_of_own.h"
#include "Text.h"

namespace MM
{
class Command;

class Module
{
    Text                    name_;
    Array_of_own <Command>  command_;

public:        
    explicit        Module  (Text const & name);
    virtual        ~Module() {}
    virtual void    init    () =0;
    static void     init_all();
    Text const &    name () const               {return name_;}

protected:
    Module_handle   adopt_command (Command * cmd) ;
    void            insert_menu_separator (Text const& menu);

private:
    friend Module_handle::~Module_handle ();
    void            adopt (Command * adoptee)   {command_.push_back (adoptee);}
};

}//MM

#endif //MODULE_H
