#ifndef PRESSURE_UNIT_H
#define PRESSURE_UNIT_H

#ifndef UNIT_H
#include "Unit.h"
#endif

namespace MM
{

class Pressure_unit : public Unit
{
    double  value_;     // atmosphere

public:
    explicit     Pressure_unit () : value_(0.) {set_current_type("atm");}
    Unit *       clone () const;

    double      atm     () const        {return   value_;}
    void        set_atm (double value)  {value_ = value;}

    // Unit interface
    double      value (Text const & current_type) const;
    void        set_value (double new_value, Text const & current_type);

    int         type_count () const         {return 1;}
    Text const& type (int n)  const;
};

}//MM

#endif //PRESSURE_UNIT_H
