#include "Mass.h"

#include "Atom.h"
#include "Atom_group.h"
#include "Element.h"

namespace MM
{

Mass::
Mass (Atom_group const & group)
:
    group_(group)
{
    for (int i=0;  i<group_.atom_count(); ++i)
    {
        double inv_mass = 1. / group_.atom(i).element().mass ();
        inv_mass_.push_back (inv_mass);
        inv_mass_.push_back (inv_mass);
        inv_mass_.push_back (inv_mass);
    }
}


int Mass::
size () const
{
    return inv_mass_.size();
}

}//MM

