#include "Build_module.h"

#include "Form_sequence_editor.h"
#include "Peep.h"
#include "Fine_type.h"
#include "Model.h"
#include "Model_kit.h"
#include "Project.h"
#include "Cleaner.h"
#include "Atom_kit.h"
#include "User.h"

namespace MM
{
Build_module  Build_module::singleton_;

Build_module::Build_module () : Module ("Edit") { } //fix to edit

void  Build_module::
init ()
{
    class Edit_sequence : public Command
    {
    public:
        void execute()  {Form_sequence_editor::pop_up ();} 
        //fix to create_command or prototipe<> ?
    };

    adopt_command (new Edit_sequence)
        .set_icon       ("sequence.png")
        .set_tool_tip   ("Edit sequence")
        .set_menu       ("&Edit", "Se&quence");

    insert_menu_separator ("&Edit");


    adopt_command (create_command (*this, &Build_module::assign_force_field))
        .set_menu        ("&Edit", "Assign &FF types");

    adopt_command (create_command (*this, &Build_module::strip))
        .set_menu        ("&Edit", "&Strip");

}

void Build_module::
assign_force_field ()
{
    Text         ff;
    Array <Text> ff_list;
    int          n;

    Fine_type::force_field_list (ff_list);

    if (to_user().choose ("Assign Force Field types for atoms.", 
        ff_list, ff, n))
        Project::singleton().current_model().kit().set_force_field (ff);
}

void Build_module::
strip ()
{
    Model & model = Project::singleton().current_model();
    model.kit().strip ();

/*    Cleaner cleaner(model);
    const Text zero_type = "0";

    for (int i=0;  i<model.atom_count();  ++i)
    {
        Atom & atom = model.atom (i);

        if (atom.kit().has_mm_type() 
            && zero_type == atom.kit().mm_type_c_str())
            cleaner.add (atom);
    }

    if (cleaner.is_empty())
        to_user().info ("There is nothing to strip.");//*/
}

}//MM
