#include "Crystal_module.h"

#include "Command_template.h"
#include "Form_build_crystal.h"
#include "Add_model_dialog.h"
#include "Form_add_model.h"
#include "Crystal_builder_impl.h"
#include "Prototype_repository.h"
#include "Create.h"
#include "Model.h"

namespace MM
{
Crystal_module  Crystal_module::singleton_;

Crystal_module::Crystal_module() : Module ("Edit") { }

void Crystal_module::
init ()
{
    Prototype_repository::singleton()
        .adopt ((Crystal_builder*) new Crystal_builder_impl (Prototype()));

    insert_menu_separator ("&Edit");
    
    adopt_command (create_command (*this, &Crystal_module::pop_up))
        .set_icon ("crystal.png")
        .set_menu ("&Edit", "&Build crystal");

    insert_menu_separator ("&Edit");
}

void Crystal_module::
pop_up ()
{
    Form_build_crystal::pop_up ();
}

}//MM

