#ifndef FORM_MODEL_H
#define FORM_MODEL_H

#ifndef DBC_H
#include "DbC.h"
#endif

#ifndef EVENT_H
#include "Event.h"
#endif

#include <QWidget>
#include <QFocusEvent>
#include <QResizeEvent>
#include <QCloseEvent>

class QWidget;
class WFlags;
class QVBoxLayout;

namespace MM
{
class Form_main_window;
class Model;

class Form_model : public QWidget, protected DbC
{
    Q_OBJECT

    Model &             model_;
    int                 identifier_;
    Form_main_window *  main_window_;
    QWidget *           central_widget_;
    QVBoxLayout *       layout;

public:
    Event               focus_in;
    //Event               destroy;

    explicit Form_model (Model & model, QWidget * central_widget);
    //explicit Form_model (//Form_main_window & main_window,
    //                     const char*        name = 0,
    //                     Qt::WFlags             fl = 0);
    ~Form_model();

    int                 identifier () const       {return identifier_;}
    void                set_identifier (int id)   {identifier_= id;} 
    void                set_main_window (Form_main_window *window)   {main_window_= window;} 
	
	//QWidget *			central_widget () {return central_widget_;}
    //void                set_central_widget (QWidget *central_widget);

    QSize               sizeHint () const {return QSize(400,300);}

protected:
    //void                resizeEvent(QResizeEvent *);
    void                closeEvent (QCloseEvent * e);
    void                focusInEvent (QFocusEvent *event);
    void                windowActivationChange (bool oldActive);
};

}//MM

#endif //FORM_MODEL_H
