#if defined WIN32
#pragma warning(disable : 4786)
#endif


#include <QUrl>
#include <QDesktopServices>
#include <QFileInfo>

#include "MolMeccano_application.h"

#include "Debug.h"
#include "Log.h"

#include "Create.h"
#include "Path.h"
#include "DbC.h"
#include "Module.h"
#include "Model.h"
#include "Project.h"
#include "OpenRM_model_view.h"
#include "QRMWidget.h"
#include "Qt_menu_control.h"
#include "New_model.h"
#include "Form_main_window.h"
#include "Form_about.h"
#include "Form_add_model.h"
#include "Qt_command.h"
#include "Qt_command_bool.h"
#include "Form_main_window.h"

#include "Atom.h"
#include "Atom_kit.h"
#include "Model_kit.h"
#include "Model_file.h"

#include "Current_folder.h"
#include "Save.h"
#include "Save_as.h"

#include <QMenu>
#include <QDesktopWidget>
#include <QWorkspace>
#include <QEvent>
#include <QTabBar>
#include <QToolBar>
#include <QFileDialog>
#include <QApplication>
#include <QLabel>

#include <QPlastiqueStyle>
#include <QWindowsXPStyle>
#include <QCleanlooksStyle>

//#include <QLibraryInfo>
//#include <QProcess>

#include <rm/rm.h>

//#include <process.h> //system


namespace MM
{
//int icon_size = 24;
int icon_size = 32;
//int icon_size = 48;


MolMeccano_application::
MolMeccano_application (int argc, char * argv[])
    :
    Qt_application (argc, argv)
{
}

MolMeccano_application::
~MolMeccano_application ()
{
}

void MolMeccano_application::
init ()
{
    QIcon app_icon;
    app_icon.addFile((Path::icon() + "oxadiazol16.png").c_str());
    app_icon.addFile((Path::icon() + "oxadiazol22.png").c_str());
    app_icon.addFile((Path::icon() + "oxadiazol32.png").c_str());
    qApp->setWindowIcon (app_icon);
//*/

    Qt_application:: init ();
//return;

    //QApplication:: setStyle (new QWindowsStyle);
    //QApplication:: setStyle (new QCDEStyle);
    ////QApplication:: setStyle (new QMacStyle);
    //QApplication:: setStyle (new QMotifStyle);
    //QApplication:: setStyle (new QMotifPlusStyle);
    //QApplication:: setStyle (new QPlatinumStyle);
    ////QApplication:: setStyle (new QPocketPCStyle);
    //QApplication:: setStyle (new QSGIStyle);
    //QApplication:: setStyle (new QWindowsXPStyle);

    QStyle *style;


    /*style = new QPlastiqueStyle;
    QApplication:: setStyle   (style);
    QApplication:: setPalette (QPalette (QColor(220, 220, 210)));//*/


    double k = 1.05;
    style = new QCleanlooksStyle;
    QApplication::setPalette (QPalette 
        (QColor(int(k*210), int(k*210), int(k*200))));
    //QApplication::setPalette (QPalette (QColor(252, 252, 240)));
    QApplication:: setStyle (style);
    //QApplication::setPalette(style->standardPalette());
    //QApplication::setPalette(QApplication::style()->standardPalette());
//*/


//QCheckBox, QComboBox, QFrame, QGroupBox, QLabel, QLineEdit, QListView, QPushButton, QRadioButton
//QSpinBox, QSplitter, QTableView, QTextEdit, QTreeView

    //qApp->setStyleSheet("QPushButton { color: white; border-width: 3; padding: 3px; min-width: 9ex; min-height: 2.5ex }");
    //qApp->setStyleSheet("QPushButton { border-width: 3; }");
    //qApp->setStyleSheet("QPushButton { height: 3px; }");
    //qApp->setStyleSheet("QLineEdit   { height: 3px; }");

    //qApp->setStyleSheet("QFrame, QGroupBox { margin:       4px; }");
    //qApp->setStyleSheet("* { border-width: 0px; ");
    //qApp->setStyleSheet("QGroupBox { border-width:      2px;}");
    //qApp->setStyleSheet("QFrame, QGroupBox { spacing:      2px;}");
    //qApp->setStyleSheet("*                   { padding:      2px;}");
    qApp->setStyleSheet("QLineEdit, QPushButton { min-height: 10px;}");
    qApp->setStyleSheet("QLineEdit, QPushButton { height: 10px;}");

    //qApp->setStyleSheet("QPushButton  { font: bold }");
    //qApp->setStyleSheet("QRadioButton { font: bold }");
    qApp->setStyleSheet
        ("QFrame, QAbstractButton, QComboBox, QLineEdit, QSpinBox"
        " { font: bold }");
    //qApp->setStyleSheet("QMenu { font: normal }");
    //qApp->setStyleSheet("* { font: bold }");
    //qApp->setStyleSheet("QMenuBar { font: normal }");
    //qApp->setStyleSheet("QWidget { font: bold }");

    //qApp->setStyleSheet("QPushButton { padding: 0px; }");
    //qApp->setStyleSheet("QPushButton { min-width: 9ex; }");
    //qApp->setStyleSheet("QPushButton { min-height: 2.5ex }");
    //qApp->setStyleSheet("QToolBar { margin: 0 }");

    //qApp->setStyleSheet ("Default");
    //QString styleSheet = qApp->styleSheet ();

    //QApplication::setPalette (QPalette (Qt::darkCyan));

    //QOIVWidget::init_OpenInventor();

//    model_.adopt (new MM_model());

    init_main_window ();
    init_menu ();
	Module::init_all();
    clear_menu ();


/*
    //void initializeAssistant();
     //assistantClient = new QAssistantClient(QLibraryInfo::location(QLibraryInfo::BinariesPath), 0);
     assistantClient = new QAssistantClient(Path::bin().c_str(), 0);

     QStringList arguments;
     arguments << "-profile" << QString("documentation") + QDir::separator() + QString("simpletextviewer.adp");
     assistantClient->setArguments(arguments);

     assistantClient->showPage((Path::bin() + "documentation/Documents.html").c_str());

//*/
}

void MolMeccano_application::
init_main_window ()
{
    //QDesktopWidget *desktop = QApplication::desktop();
    //main_window_->parent()->setMinimumSize (int(.75*desktop->width()), int(.75*desktop->height())); //fix

    //const QPixmap icon = QPixmap ((Text (DIR_icon) + "H2O.png").c_str());
    //main_window_->setIcon (icon);
}
/*
namespace
{
    bool & write_files_with_comments ()
    {
        static bool instance = false;
        return      instance;
    }
}//*/


void MolMeccano_application::
init_menu()
{
    new_command_.adopt (new Qt_command (new New_model ()));


    class Open : public Command, protected Current_folder
    {
        Form_main_window      & main_window_;
        //QString                 open_files_path_;

        void make_scene (Model &model, const char * name)
        {
            //make_Coin_scene (model, name);
            //make_OIV_scene  (model, name);
            make_RM_scene   (model, name);
        }

        void make_RM_scene (Model &model, const char * name)
        {

            QRMWidget *rm_widget = new QRMWidget;
            Form_model *MDI_window = new Form_model (model, rm_widget);
            MDI_window->setCaption (name);


            //3 Form_model *MDI_window = new Form_model (main_window_);
            //Form_model *MDI_window = new Form_model;
            //MDI_window->setCaption (name);
            //QRMWidget *rm_widget = new QRMWidget (MDI_window);
            //MDI_window->set_central_widget (rm_widget);
            MDI_window->focus_in.subscribe (model.kit().view(), &Model_view::set_focus);

            //MDI_window->destroy. subscribe ((Model &)model, &Model::erase);
            //MDI_window->destroy. subscribe (create_command(model, &Model::erase));
            /*class Destroy_model : public Command
            {
                Model & model_;
            public:  
                explicit Destroy_model (Model & model) : model_(model) { }
                virtual void execute () 
                {
                    model_.erase();
                }
            };
            MDI_window->destroy. subscribe (new Destroy_model (model));//*/

            main_window_.add_MDI_window (MDI_window, QFileInfo (name).baseName());
            model.kit().add_view (                             
                new OpenRM_model_view (model, *rm_widget, *MDI_window));    //fix !!!
                //new OpenRM_model_view (model, *MDI_window, nil<QRMWidget>()));    //fix !!!

            {
            //fix move to OpenRM_model_view
                model.atom_prototype().kit().add_visual 
                    (new OpenRM_atom (rm_widget->object_node(), rm_widget));
/*            Base::Atom & atom = prototype <Atom> ();
            Atom & prototype = dynamic_cast <Atom &> (atom);
//            prototype.kit().add_openRM 
//                (new OpenRM_atom (rm_widget->object_node()));
                //(new OpenRM_atom (rm_widget->scene()));

            prototype.kit().add_visual 
                (new OpenRM_atom (rm_widget->object_node(), rm_widget));//*/
            }
        }

        void make_Coin_scene (Model &model, const char * name)
        {

            /*Form_model *MDI_window = new Form_model (main_window_);
            MDI_window->setCaption (name);
            MDI_window->set_central_widget (new QWidget (MDI_window));

            model.kit().add_view (                            
                new Inventor_model_view (model, *MDI_window, MDI_window->central_widget())); 

            main_window_.add_MDI_window (MDI_window, name);//*/
        }

        void make_OIV_scene (Model &model, const char * name)
        {
        /*    Form_model *MDI_window = new Form_model (main_window_);
            MDI_window->setCaption (name);
            QOIVWidget *oiv_widget = new QOIVWidget (MDI_window);
            //MDI_window->set_central_widget (new QWidget (MDI_window));
            MDI_window->set_central_widget (oiv_widget);
            main_window_.add_MDI_window (MDI_window, name);

            model.kit().add_view (                            
                new OpenInventor_model_view (model, *MDI_window, *oiv_widget)); 
                //*/
        }

        class MouseMoveEater : public QObject //work around Q_WS_WIN bug.
        {
        protected:
            bool eventFilter (QObject *, QEvent *e)
            {
                if (e->type() == QEvent::MouseMove )
                    return TRUE;  // eat event
                else 
                    return FALSE; // standard event processing
            }
        };

    public:
        explicit Open (Form_main_window & main_window)
            :   
            main_window_(main_window)//,
//            open_files_path_("")
        {
            //Form_model *MDI_window = new Form_model (main_window_);
            //MDI_window->setCaption (name);
            //QRMWidget *rm_widget = new QRMWidget (MDI_window);
            //MDI_window->set_central_widget (rm_widget);
            ///MDI_window->focus_in.subscribe (model.kit().view(), Model_view::set_focus);
            //main_window_.add_MDI_window (MDI_window, "");
            //model.kit().add_view (                             
            //    new OpenRM_model_view (&model, *rm_widget));    //fix !!!
                //new OpenRM_model_view (model, *MDI_window, nil<QRMWidget>()));    //fix !!!

            //fix move to OpenRM_model_view
            //model.atom_prototype().kit().add_visual 
            //    (new OpenRM_atom (rm_widget->object_node(), rm_widget));

//            Prototype_repository::singleton().
//                adopt ((Model_view*) new OpenRM_model_view ()); //fix to 1 time
        }

        void execute()
        {
            MouseMoveEater *mouseMoveEater = new MouseMoveEater ();
            qApp->installEventFilter (mouseMoveEater);

            
            Text all_chemical;
            Text individual;
            all_chemical += "All chemical (";
            
            int k = Model_file::prototype_count();
            bool first_all_chemical_record = true;

            for (int i=0;  i<k;  ++i)
            {
                Model_file const & file_type = Model_file::prototype (i);
                
                if (file_type.support_input())
                {
                    if (!individual.is_empty())
                        individual += ";;";

                    individual += file_type.type_name();

                    int type_name_length = file_type.type_name().length();
                    for (int space=type_name_length;  space<12;  ++space)
                        individual += " ";

                    individual += " (";

                    if (!first_all_chemical_record)
                        all_chemical += " ";
                    first_all_chemical_record = false;

                    int  n = file_type.extension_count();
                    bool first_extension_record = true;

                    for (int j=0;  j<n;  ++j)
                    {
                        if (!first_extension_record)
                        {
                            individual   += " ";
                            all_chemical += " ";
                        }
                        first_extension_record = false;

                        individual   += "*.";
                        all_chemical += "*.";
                        individual   += file_type.extension(j);
                        all_chemical += file_type.extension(j);
                    }

                    individual += ")";
                }
            }
            all_chemical += ");;";
            all_chemical += "";
            Text text;
            text += all_chemical;
            text += "All files    (*.*);;";
            text += individual;
            //log () << text << "\n\n";

            //QString path = qApp->applicationDirPath();
            QString selected_filter;
            /*QString file_name = Q3FileDialog::
                //getOpenFileName (QString::null, text.c_str(), &main_window_ );
                getOpenFileName (path, text.c_str(), &main_window_,
                "open file dialog", "Choose a file to open", &selected_filter);//*/
            
            ///QString file_name = QFileDialog::getOpenFileName (
            QStringList file_name = QFileDialog::getOpenFileNames (
                main_window_.parent(),
                "Open file",
                path (), 
                text.c_str(), //filter
                &selected_filter
                );

            log() << "Filter: " << selected_filter.ascii() << "\n";

            //QFileDialog* dialog = new QFileDialog 
            //    (qApp->applicationDirPath(), text.c_str(), &main_window_, "Open");
            //dialog->setMode (QFileDialog::AnyFile);
            //dialog->setFilter (text.c_str());
            //dialog->setViewMode( QFileDialog::Detail );
            
//            QString file_name;
//            if (dialog->exec() == QDialog::Accepted)
//                file_name = dialog->selectedFile();

            //QString selected_filter = dialog->selectedFilter()
            QString file_type_name = selected_filter
                .section('(', 0, 0)
                .stripWhiteSpace ();

            Text file_type;
            //if (selected_filter == "All files" || selected_filter == "All chemical") 
            if (file_type_name == "All files"    || 
                file_type_name == "All chemical" ||
                file_type_name.isEmpty()//fix
               ) 
                file_type = "auto detect";
            else
                //file_type = selected_filter.latin1();
                file_type = file_type_name.latin1();



            /*QString file_name = QFileDialog::
                getOpenFileName( 
                    QString::null, 
                    "All chemical     (*.pdb *.ent *.xyz *.hin *.mol2 *.ml2 *.xmol);;"
                    "Protein Data Bank     (*.pdb *.ent);;"
                    "HyperChem     (*.hin);;"
                    "Mol2     (*.mol2 *.ml2);;"
//                    "M.Dynamix    (*.mol);;"
                    "XYZ     (*.xyz *.xmol);;"
                    "Protein with hydrogen     (*.hhh);;"  //fix
                    "All files     (*.*);;",
                    &main_window_ );//*/

            /*if (!file_name.isEmpty())     //fix
            {
                path () = file_name;

                //fix to:  Model *model = new New_model (file_name);
                Model *model = prototype <Model> ().clone();
                //singleton <Model_manager>().adopt (model);
                //3 qApp->processEvents (10);
                qApp->processEvents (QEventLoop::AllEvents, 10);
                make_scene  (*model, file_name);
                model->load (file_name.latin1 (), file_type);
                model->kit().view().fit_to_screen();
                Project::singleton().adopt (model);
            }//*/

            QStringList::Iterator it = file_name.begin();
            while (it != file_name.end()) 
            {
                path () = *it;

                //fix to:  Model *model = new New_model (file_name);
                Model *model = prototype <Model> ().clone();
                //singleton <Model_manager>().adopt (model);
                qApp->processEvents (QEventLoop::AllEvents, 10);
                make_scene  (*model, *it);
                model->load ((*it).latin1 (), file_type);
                model->kit().view().fit_to_screen();
                Project::singleton().adopt (model);

                ++it;
            }

            qApp->removeEventFilter (mouseMoveEater);
            delete mouseMoveEater;
        }
    };
    open_command_.adopt (new Qt_command (new Open (*main_window_)));


    class Add : public Command, protected Current_folder
    {
        Form_main_window      & main_window_;
        //QString                 open_files_path_;

    public:
        explicit Add (Form_main_window & main_window) 
            : main_window_(main_window) { }

        void execute()
        {
            //MouseMoveEater *mouseMoveEater = new MouseMoveEater ();
            //qApp->installEventFilter (mouseMoveEater);
            
            Text all_chemical;
            Text individual;
            all_chemical += "All chemical (";
            
            int k = Model_file::prototype_count();
            bool first_all_chemical_record = true;

            for (int i=0;  i<k;  ++i)
            {
                Model_file const & file_type = Model_file::prototype (i);
                
                if (file_type.support_input())
                {
                    if (!individual.is_empty())
                        individual += ";;";

                    individual += file_type.type_name();

                    int type_name_length = file_type.type_name().length();
                    for (int space=type_name_length;  space<12;  ++space)
                        individual += " ";

                    individual += " (";

                    if (!first_all_chemical_record)
                        all_chemical += " ";
                    first_all_chemical_record = false;

                    int  n = file_type.extension_count();
                    bool first_extension_record = true;

                    for (int j=0;  j<n;  ++j)
                    {
                        if (!first_extension_record)
                        {
                            individual   += " ";
                            all_chemical += " ";
                        }
                        first_extension_record = false;

                        individual   += "*.";
                        all_chemical += "*.";
                        individual   += file_type.extension(j);
                        all_chemical += file_type.extension(j);
                    }
                    
                    individual += ")";
                }
            }
            all_chemical += ");;";
            all_chemical += "";
            Text text;
            text += all_chemical;
            text += "All files    (*.*);;";
            text += individual;
            //log () << text << "\n\n";

            //QString file_name = Q3FileDialog::
            //    getOpenFileName (QString::null, text.c_str(), &main_window_ );

            QString selected_filter;
            QString file_name = QFileDialog::getOpenFileName (
                main_window_.parent(),
                "Choose a file to add",
                path (), //path
                text.c_str(), //filter
                &selected_filter
                );

            /*QString file_name = QFileDialog::
                getOpenFileName( 
                    QString::null, 
                    "All chemical     (*.pdb *.ent *.xyz *.hin *.mol2 *.ml2 *.xmol);;"
                    "Protein Data Bank     (*.pdb *.ent);;"
                    "HyperChem     (*.hin);;"
                    "Mol2     (*.mol2 *.ml2);;"
//                    "M.Dynamix    (*.mol);;"
                    "XYZ     (*.xyz *.xmol);;"
                    "Protein with hydrogen     (*.hhh);;"  //fix
                    "All files     (*.*);;",
                    &main_window_ );//*/

            if (!file_name.isEmpty())     //fix
            {
                path () = file_name;

                Model & model = Project::singleton().current_model ();
                //qApp->processEvents (10);
                model.kit().add_builder().load (file_name.latin1 ());//fix file_type
                if (Form_add_model::exist())
                    Form_add_model::singleton()->reset_current_model (model);

                //fix !!!
                //Form_add_model::singleton()->pop_up();
                ////////Form_add_model::pop_up();
                
                //Own <Model> new_model (prototype<Model>().clone());
                //new_model().set_atom_prototype (model.atom_prototype().clone());
                //new_model().load (file_name.latin1 ());
                //qApp->processEvents (10);
                //Form_add_model dialog (model, new_model(), &main_window_);
                //dialog.exec();
            }

            //qApp->removeEventFilter (mouseMoveEater);
            //delete mouseMoveEater;
        }
    };
    add_command_.adopt (new Qt_command (new Add (*main_window_)));

    class Pull_on : public Command, protected Current_folder
    {
        Form_main_window      & main_window_;
        //QString                 open_files_path_;

    public:
        explicit Pull_on (Form_main_window & main_window) 
            : main_window_(main_window) { }

        void execute()
        {
            if (Project::singleton().model_count() == 0)
                return;

            Text all_chemical;
            Text individual;
            all_chemical += "All chemical (";
            
            int k = Model_file::prototype_count();
            bool first_all_chemical_record = true;

            for (int i=0;  i<k;  ++i)
            {
                Model_file const & file_type = Model_file::prototype (i);
                
                if (file_type.support_input())
                {
                    if (!individual.is_empty())
                        individual += ";;";

                    individual += file_type.type_name();

                    int type_name_length = file_type.type_name().length();
                    for (int space=type_name_length;  space<12;  ++space)
                        individual += " ";

                    individual += " (";

                    if (!first_all_chemical_record)
                        all_chemical += " ";
                    first_all_chemical_record = false;

                    int  n = file_type.extension_count();
                    bool first_extension_record = true;

                    for (int j=0;  j<n;  ++j)
                    {
                        if (!first_extension_record)
                        {
                            individual   += " ";
                            all_chemical += " ";
                        }
                        first_extension_record = false;

                        individual   += "*.";
                        all_chemical += "*.";
                        individual   += file_type.extension(j);
                        all_chemical += file_type.extension(j);
                    }

                    individual += ")";
                }
            }
            all_chemical += ");;";
            all_chemical += "";
            Text text;
            text += all_chemical;
            text += "All files    (*.*);;";
            text += individual;
            //log () << text << "\n\n";

            //QString file_name = Q3FileDialog::
            //    getOpenFileName (QString::null, text.c_str(), &main_window_ );

            QString selected_filter;
            QString file_name = QFileDialog::getOpenFileName (
                main_window_.parent(),
                "Choose a file to pull on",
                path (),
                text.c_str(), //filter
                &selected_filter
                );

            /*QString file_name = QFileDialog::
                getOpenFileName( 
                    QString::null, 
                    "All chemical     (*.pdb *.ent *.xyz *.hin *.mol2 *.ml2 *.xmol);;"
                    "Protein Data Bank     (*.pdb *.ent);;"
                    "HyperChem     (*.hin);;"
                    "Mol2     (*.mol2 *.ml2);;"
//                    "M.Dynamix    (*.mol);;"
                    "XYZ     (*.xyz *.xmol);;"
                    "Protein with hydrogen     (*.hhh);;"  //fix
                    "All files     (*.*);;",
                    &main_window_ );//*/

            if (!file_name.isEmpty())     //fix
            {
                path () = file_name;

                Model & model = Project::singleton().current_model ();
                model.pull_on (file_name.latin1 ());
            }
        }
    };
    pull_on_command_.adopt (new Qt_command (new Pull_on (*main_window_)));

    save_as_command_.adopt (new Qt_command (new Save_as (main_window_)));

    save_command_.adopt (new Qt_command (new Save (main_window_)));

    class Save_all : public Command, protected Current_folder
    {
        Form_main_window      * main_window_;//fix make * to all

    public:
        explicit Save_all (Form_main_window *parent_widget)
            : main_window_(parent_widget) { }

        void execute()
        {
            Project & project = Project::singleton();

            for (int i=0;  i<project.model_count();  ++i)
            {
                Model & model = project.model(i);

                if (!model.kit().file().was_defined())
                {
					Project::singleton().set_current_model (model);
                    Save_as save_as (main_window_, model);
                    save_as.execute();
                    continue;
                }

                Text file_name = model.kit().file().file_name();

	            if (model.save (write_files_with_comments ()))
                {
                    to_user().status (Text("File ") + file_name + " saved.");
                }
                else
                    to_user().warning (Text("Can not save file ") + file_name);
                }
        }
    };
    save_all_command_.adopt (new Qt_command (new Save_all (main_window_)));


    class Synchonize_folders : public Command_1 <bool>
    {
    public:
        void execute (bool on)
        {
            Current_folder::singleton().synchonize (on);
        }
    };
    synchonize_folders_command_.adopt (new Qt_command_bool 
        (new Synchonize_folders()));

    class Write_files_with_comments : public Command_1 <bool>, protected Current_folder
    {
    public:
        void execute (bool on)
        {
            write_files_with_comments () = on;
        }
    };
    files_with_comments_command_.adopt (new Qt_command_bool 
        (new Write_files_with_comments()));

    class Close : public Command
    {
    public:
        void execute() {Project::singleton().current_model().clear();}
    };

    struct Exit : public Command
    {
        void  execute() {qApp->quit();}
    };
    exit_command_.adopt (new Qt_command (new Exit()));


    class Toggle_scroll_bars_command : public Command_1 <bool>
    {
        Form_main_window    & main_window_;

    public:
        explicit Toggle_scroll_bars_command (Form_main_window & main_window)
            : main_window_(main_window) { }

        void  execute (bool flag) 
        {
            main_window_.workspace->setScrollBarsEnabled (flag);
        }
    };
    toggle_scroll_bars_command_.adopt (new Qt_command_bool 
        (new Toggle_scroll_bars_command (*main_window_)));


    //=========================================================================
    QMenu    *file_menu     = main_window_->menu     (QObject::tr("&File"));
    QToolBar *file_tool_bar = main_window_->tool_bar (QObject::tr("File"));
    //file_tool_bar->setIconSize (QSize (32, 32));
    //file_tool_bar->setIconSize (QSize (64, 64));
    file_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    QIcon new_icon = QIcon((Path::icon() + icon_size + "/" + "new.png").c_str());
    new_icon.addFile ((Path::icon() + "none-16.png").c_str());
    QAction *new_action = 
        new QAction (new_icon, "&New", main_window_->parent());
    new_action->setShortcut (QObject::tr("Ctrl+N"));
    QObject::connect (new_action,       SIGNAL(triggered()), 
                     &new_command_(),   SLOT(execute()));
    file_tool_bar->addAction (new_action);
    file_menu->    addAction (new_action);

    QIcon open_icon = QIcon((Path::icon() + icon_size + "/" + "open.png").c_str());
    open_icon.addFile ((Path::icon() + "none-16.png").c_str());
    QAction *open_action = 
        new QAction (open_icon, "&Open", main_window_->parent());
    open_action->setShortcut (QObject::tr("Ctrl+O"));
    QObject::connect (open_action,      SIGNAL(triggered()), 
                     &open_command_(),  SLOT(execute()));
    file_tool_bar->addAction (open_action);
    file_menu->    addAction (open_action);

    QAction *add_action = 
        new QAction ("&Add", main_window_->parent());
    QObject::connect (add_action,       SIGNAL(triggered()), 
                     &add_command_(),   SLOT(execute()));
    file_menu->    addAction (add_action);

    QAction *pull_on_action = 
        new QAction ("&Pull on", main_window_->parent());
    QObject::connect (pull_on_action,       SIGNAL(triggered()), 
                     &pull_on_command_(),   SLOT(execute()));
    file_menu->    addAction (pull_on_action);

    file_menu->addSeparator ();

    QAction *same_folder_action = new QAction 
        ("Same &folder", main_window_->parent());
    same_folder_action->setToggleAction (true);
    same_folder_action->setOn           (true);
    QObject::connect (same_folder_action,             SIGNAL (toggled(bool)), 
                      &synchonize_folders_command_(), SLOT   (execute(bool)));
    file_menu->    addAction (same_folder_action);

    file_menu->addSeparator ();

    QAction *save_as_action = 
        new QAction ("Sa&ve as...", main_window_->parent());
    QObject::connect (save_as_action,       SIGNAL(triggered()), 
                     &save_as_command_(),   SLOT(execute()));
    file_menu->    addAction (save_as_action);

    QIcon save_icon = QIcon((Path::icon() + icon_size + "/" + "save.png").c_str());
    save_icon.addFile ((Path::icon() + "none-16.png").c_str());
    QAction *save_action = 
        new QAction (save_icon, "&Save", main_window_->parent());
    save_action->setShortcut (QObject::tr("Ctrl+S"));
    QObject::connect (save_action,       SIGNAL(triggered()), 
                     &save_command_(),   SLOT(execute()));
    file_tool_bar->addAction (save_action);
    file_menu->    addAction (save_action);

    QIcon save_all_icon = QIcon((Path::icon() + icon_size + "/" + "save_all.png").c_str());
    save_all_icon.addFile ((Path::icon() + "none-16.png").c_str());
    QAction *save_all_action = 
        new QAction (save_all_icon, "Save A&ll", main_window_->parent());
    QObject::connect (save_all_action,       SIGNAL(triggered()), 
                     &save_all_command_(),   SLOT(execute()));
    file_tool_bar->addAction (save_all_action);
    file_menu->    addAction (save_all_action);

    QAction * with_comments = 
        new QAction ("With &comments", main_window_->parent());
    with_comments->setToggleAction (true);
    //with_comments->setOn           (write_files_with_comments ());
    with_comments->setOn (Current_folder::singleton ().write_files_with_comments ());
    QObject::connect (with_comments,                   SIGNAL (toggled(bool)), 
                      &files_with_comments_command_(), SLOT   (execute(bool)));
    file_menu->    addAction (with_comments);

    file_menu->addSeparator ();

    QAction *exit_action = 
        new QAction ("E&xit", main_window_->parent());
    QObject::connect (exit_action,       SIGNAL(triggered()), 
                     &exit_command_(),   SLOT(execute()));
    file_menu->    addAction (exit_action);

    //=========================================================================
//    QMenu    *edit_menu     = 
        main_window_->menu     (QObject::tr("&Edit"));
    QToolBar * edit_tool_bar =  main_window_->tool_bar (QObject::tr("Edit"));
    edit_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    //=========================================================================
//    QMenu    *view_menu     = 
       main_window_->menu     (QObject::tr("&View"));
    QToolBar *view_tool_bar = main_window_->tool_bar (QObject::tr("View"));
    view_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    //=========================================================================
//    QMenu    *build_menu     = 
        main_window_->menu     (QObject::tr("&Build"));
    QToolBar *build_tool_bar = main_window_->tool_bar (QObject::tr("Build"));
    build_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    //=========================================================================
//    QMenu    *selection_menu     = 
        main_window_->menu     (QObject::tr("&Selection"));

    QToolBar *selection_tool_bar = 
        main_window_->tool_bar (QObject::tr("Selection"));
    selection_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================


    //=========================================================================
//    QMenu    *analyse_menu     = 
        main_window_->menu     (QObject::tr("&Analyse"));

    QToolBar *analyse_tool_bar = 
        main_window_->tool_bar (QObject::tr("Analyse"));
    analyse_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================


    //=========================================================================
//    QMenu    *compute_menu     = 
        main_window_->menu     (QObject::tr("&Compute"));

    QToolBar *compute_tool_bar = 
        main_window_->tool_bar (QObject::tr("Compute"));
    compute_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================


    //=========================================================================
//    QMenu    *tools_menu     = 
        main_window_->menu     (QObject::tr("&Tools"));
    QToolBar *tools_tool_bar = main_window_->tool_bar (QObject::tr("Tools"));
    tools_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    //=========================================================================
//    QMenu    *database_menu     = 
        main_window_->menu     (QObject::tr("&Database"));

    QToolBar *database_tool_bar = 
        main_window_->tool_bar (QObject::tr("Database"));
    database_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    //=========================================================================
//    QMenu    *test_menu     = 
        main_window_->menu     (QObject::tr("&Test"));
    QToolBar *test_tool_bar = main_window_->tool_bar (QObject::tr("Test"));
    test_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    //=========================================================================
//    QMenu    *window_menu     = 
        main_window_->menu    (QObject::tr("&Window"));
    QToolBar *window_tool_bar = main_window_->tool_bar (QObject::tr("Window"));
    window_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================

    QIcon tile_icon = QIcon((Path::icon() +icon_size+"/"+ "tile.png").c_str());
    tile_icon.addFile ((Path::icon() + "none-16.png").c_str());
    QAction *tile_action = 
        new QAction (tile_icon, "&Tile", main_window_->parent());
    QObject::connect (tile_action,              SIGNAL(triggered()), 
                      main_window_->workspace,  SLOT  (tile ()));
    window_tool_bar->addAction (tile_action);
//    window_menu->    addAction (tile_action);

    QIcon cascade_icon = 
        QIcon((Path::icon() + icon_size + "/" + "cascade.png").c_str());
    cascade_icon.addFile ((Path::icon() + "none-16.png").c_str());
    QAction *cascade_action = 
        new QAction (cascade_icon, "&Cascade", main_window_->parent());
    QObject::connect (cascade_action,           SIGNAL(triggered()), 
                      main_window_->workspace,  SLOT  (cascade ()));
    window_tool_bar->addAction (cascade_action);
//    window_menu->    addAction (cascade_action);

    QIcon scroll_bars_icon = 
        QIcon((Path::icon() + icon_size + "/" + "scroll_bars.png").c_str());
    scroll_bars_icon.addFile ((Path::icon() + "none-16.png").c_str());
    QAction *scroll_bars_action = 
        new QAction (scroll_bars_icon, "&Scroll_bars", main_window_->parent());
    scroll_bars_action->setToggleAction (true);
    scroll_bars_action->setOn           (false);
    QObject::connect (scroll_bars_action,              SIGNAL(toggled(bool)), 
                      &toggle_scroll_bars_command_(),  SLOT  (execute (bool)));
    window_tool_bar->addAction (scroll_bars_action);
//    window_menu->    addAction (scroll_bars_action);

    //=========================================================================
    QMenu    *help_menu     = 
        main_window_->menu     (QObject::tr("&Help"));
    QToolBar *help_tool_bar = main_window_->tool_bar (QObject::tr("Help"));
    help_tool_bar->setIconSize (QSize (icon_size, icon_size));
    //=========================================================================//*/

    struct Contents : public Command 
    {
        void  execute() 
        {
            Text command;
            command += Path::doc();
            command += "Documents.html";
            
            QString   str (command.c_str());
            QFileInfo file(str);
            QUrl      url = QUrl::fromLocalFile (file.absoluteFilePath());
            QDesktopServices::openUrl (url);
        }
    };
    contents_command_.adopt (new Qt_command (new Contents()));

    QAction *contents_action = 
        new QAction ("&Contents", main_window_->parent());
    QObject::connect (contents_action,             SIGNAL(triggered()), 
                      &contents_command_(),        SLOT  (execute ()));
    help_menu->addAction (contents_action);

    // &Getting Started
    // &User Guide

    struct About : public Command {void  execute() {Form_about().exec();}};
    about_command_.adopt (new Qt_command (new About()));

    QAction *about_action = 
        new QAction ("&About", main_window_->parent());
    QObject::connect (about_action,             SIGNAL(triggered()), 
                      &about_command_(),        SLOT  (execute ()));
    help_menu->addAction (about_action);
}

void MolMeccano_application::
clear_menu()
{
    main_window_->remove_empty_menus ();
    main_window_->remove_empty_tool_bars ();
}

}//MM
