#ifndef OPENRM_MODEL_VIEW_H
#define OPENRM_MODEL_VIEW_H

#ifndef MODEL_VIEW_H
#include "Model_view.h"
#endif

class QRMWidget;

namespace MM
{
class Model;
class Form_model;
template <class T> class Owner;

class OpenRM_model_view : public Model_view
{
    Model                           *model_;
    QRMWidget                       *rm_widget_;
    Form_model                      *MDI_window_;

public:
    OpenRM_model_view () : model_(0), rm_widget_(0) {}

    OpenRM_model_view (Model      & model,
                       QRMWidget  & rm_widget,
                       Form_model & MDI_window);

    virtual Model_view *clone (Model &model, const char * name) const;

    //void            set_model (Model &model) {model_ = &model;}

    void            fit_to_screen();
    void            flush_camera ();
    void            set_level_of_details (int lod);
    void            set_focus ();
    void            get_dimensions (double &center_x,
                                    double &center_y,
                                    double &center_z,
                                    double &scale);
};

}//MM

#endif //OPENRM_MODEL_VIEW_H
