#include "Test.h"

#include <qdialog.h>
#include <qlabel.h>
#include <qpainter.h>
//Added by qt3to4:
#include <QPaintEvent>

#include <typeinfo>


//#include "Image.h"
#include "Image_3D.h"
#include "Z_buffer.h"
#include "Painter_3D.h"
#include "Test_sphere.h"
#include "Performance.h"

#include "ViewObj.h"


namespace MM
{

class Qt_painter_3D_test : public Test
{
public:
    Qt_painter_3D_test( const Text & suite_name ) : Test( suite_name ) { }

    void run()
    {
        test_spheres();
    }

    virtual void    test_spheres();
};

//Qt_painter_3D_test qt_painter_3D_test("performance");
Qt_painter_3D_test test_qt_painter_3D ("temporary");

namespace 
{

class Test_spheres_dialog : public QDialog
{
    Image                       image_;
    Image_3D                    image_3D_;

//    QStatusBar                  *status_bar_;
    QLabel                      *status_bar_label_;

public:
    Test_spheres_dialog()
    : 
        QDialog( 0,0, TRUE ), 
        image_( 300, 300 ),
        image_3D_( image_ )
    {
        //status_bar_ = new QStatusBar( this );

        status_bar_label_ = new QLabel( this, "message" );
        //status_bar_label_ = new QLabel( status_bar_, "message" );
        status_bar_label_->setAlignment( Qt::AlignCenter );
        //status_bar_->addWidget( status_bar_label_, 4 );

        status_bar_label_->setText("This is a Status Bar");
    }


    void paintEvent( QPaintEvent*)
    {
    //Image                       image_(300, 300 );
    //Image_3D                    image_3D_( image_ );
        Painter_3D  painter( image_3D_ );
        int         x = 0, y = 0, z = 0;

        Test_sphere sphere1( 200+x, 200+y, 130+z, 70 );
        Material material;
        material.R_ = 255;
        material.G_ = 0;
        material.B_ = 0;
        //type.
        sphere1.material_ = material;
        //Test_sphere sphere2( 270+x, 200+y, 110+z, 70 );
        //Test_sphere sphere3( 340+x, 200+y, 150+z, 70 );
        //Test_sphere sphere4( 410+x, 200+y, 130+z, 70 );

        sphere1.set_attributes(); //fix remove

        double t1 = Test_Performance::get_time();

        painter.sphere(&sphere1, 50);
        //painter.sphere( 270+x, 200+y, 110+z, 70 );
        //painter.sphere( &sphere2 );
        //painter.sphere( &sphere3 );
        //painter.sphere( &sphere4 );

        double t2 = Test_Performance::get_time();
        status_bar_label_->setText( Text(t2-t1).c_str() );

        QPainter qpainter(this);
        qpainter.drawImage( QPoint(0,0), image_.qimage() );//*/
    }
};

}//namespace

void    Qt_painter_3D_test::
test_spheres()
{
    Test_spheres_dialog().exec();
}

}//MM
