// 
// This file is part of MolMeccano, a cross-platform C++ chemical library.
//
// Copyright (C) 2001-2007 Alexey Nikitin
//
#include "Qt_text_output.h"

#include "Text.h"
#include "Log.h"

#include <qlayout.h> 
#include <q3textview.h> 

//#include <Q3BoxLayout.h> 
#include <QHBoxLayout> 

namespace MM
{

Qt_text_output::Qt_text_output( QWidget * parent, const char * name )
:   QDialog( parent, name )
{
    text_view_ = new Q3TextView( this ); 

//    Q3BoxLayout *layout = new Q3BoxLayout( this, Q3BoxLayout::LeftToRight );
    QHBoxLayout *layout = new QHBoxLayout (this);
    layout->addWidget( text_view_ ); 

    setMinimumWidth ( 300 );
    setMinimumHeight( 300 );
}

Text_output & Qt_text_output::line( const Text & text )
{
    text_view_->append( (text+"\n").c_str() );
    return * this;
}

Text_output & Qt_text_output::text( const Text & text )
{
//    logger() << "\n" << text << "\n";
    text_view_->append( text.c_str() );
    return * this;
}

}//MM
